/*
  LϢ³ؿȤƤκǾ,ΥؿȤƸβεΥפ

  Ϣ³ؿ 1/PRECIOUS ٤ΥŬ롼ѤƵ롣

  2007/6/28
*/


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>
#include "odicon.h"

#define PRECIOUS 1000.0


int inited = FALSE;
double a[10] = { 0.99, -0.01, 1, 0 };
double b[10] = { 0, 1.01, 2.01, 3.01 };
double c = 1000.0;

double input_double(void) {
    double tmp;
    if (scanf("%lf", &tmp) == 1) return tmp;
    return -32768;
}

void input(const int dim) {
    int i;

    printf("Give me problem instance.\n");
    inited = TRUE;
    for (i=0; i<dim; i++) {
        double tmp = input_double();
        if (tmp == -32768) return;
        a[i] = tmp;
    }
    for (i=0; i<dim; i++) b[i] = input_double();
    c = input_double();
}

/* Ǥξ¦ʬ */
static double double_f6(int dim, double *x);
static double double_f1(int dim, double *x) {
    int i;
    int dim1 = dim / 2;
    int dim2 = dim - dim1;
    double x2[100];

    for (i=0; i<dim2; i++) x2[i] = -x[dim1+i];
    return double_f6(dim1, x) + double_f6(dim2, x2);
}

/*  */
static double double_f6(int dim, double *x) {
    const double a = 0.01;
    int i;
    double r = -(dim-1) * (1-a);

    r += fabs(x[0] - x[dim-1] + dim-1);
    for (i=1; i<dim; i++) {
        r += fabs(x[i-1] - x[i] + a);
    }
    for (i=0; i<dim; i++) {
        if (x[i] < a) r += -10 * (x[i] - a);
        else r += (x[i]-a) * a / dim;
    }
    return r;
} 

/* ѥȥå */
static double double_f5(int dim, double *x) {
    int i;
    double r;

    if (!inited) input(dim);
    r = fabs(x[dim-1] - x[0] + a[0]);
    for (i=1; i<dim; i++) {
        r += fabs(x[i-1] - x[i] + a[i]);
    }
    for (i=0; i<dim; i++) {
        if (x[i] < b[i]) r += -10 * (x[i] - b[i]);
        r += x[i] / c;
    }
    return r;
}

/* 3 */
static double double_f4(int dim, double *x) {
    double r = 0;

    assert(dim == 3);
    r += fabs(x[1] - x[0] - 0.01);
    r += fabs(x[2] - x[1] + 1);
    r += fabs(x[0] - x[2] + 0.99);
    if (x[1] < 1.01) r += -10 * (x[1] - 1.01);
    if (x[2] < 2.01) r += -10 * (x[2] - 2.01);
    r += x[1] / 1000.0;
    r += x[2] / 1000.0;
    return r;
}


static double double_f3(int dim, double *x) {
    double r = 0;

    assert(dim == 3);
    r += fabs(x[0] - x[1] + 0.9);
    r += fabs(x[1] - x[2] + 1);
    r += fabs(x[2] - x[0] - 0.1);
    if (x[1] <  0.1) r += -10 * (x[1] - 0.1);
    if (x[2] < -0.7) r += -10 * (x[2] + 0.7);
    r += x[0] / 10.0;
    return r;
}


static double double_f2(int dim, double *x) {
    double r = 0;

    r += fabs(x[0] - x[1] + 0.2);
    if (x[1] < 0.1) r += -10 * (x[1] - 0.1);
    r += x[1] / 10.0;
    return r;
}


/* ؿ */
static double f1(int dim, int x[]) {
    int i;
    double y[100];

    for (i=0; i<dim; i++) y[i] = x[i];
    return double_f1(dim, y);
}

/* ¿ؿ */
static double f1d(int dim, int x[]) {
    int i;
    double y[100];

    for (i=0; i<dim; i++) y[i] = (double)x[i] / PRECIOUS;
    return double_f1(dim, y);
}


void lconv_long(const int dim) {
    int i;
    int *init1 = ivector_new(dim);
    int *init2 = ivector_new(dim);
    double error, e1 = 0, e2 = 0;

    for (i=0; i<dim; i++) init1[i] = 0;
    if (dim > 0) init1[0] = PRECIOUS * -1;
    if (dim > 2) init1[2] = PRECIOUS * -1;

    /* ʰ׼¿ */
    printf("--------------------------\n");
    lgconv_minimize(dim, f1d, init1);
    /* ͤ˴ݤ */
    for (i=0; i<dim; i++) init2[i] = (int)floor(init1[i]/PRECIOUS);
    /*  */
    printf("--------------------------\n");
    lgconv_minimize(dim, f1, init2);

    /* ƱΤεΥ */
    printf("--------------------------\n");
    for (i=0; i<dim; i++) {
        error = init2[i] - init1[i]/PRECIOUS;
        printf("error[%d] = %g (%d vs %g)\n", i, error,
               init2[i],  init1[i]/PRECIOUS);
        if (fabs(error) > fabs(e2)) {
            if (fabs(error) > fabs(e1)) { e2 = e1; e1 = error; }
            else { e2 = error; }
        }
    }
    printf("\nmax error = %g\nsecond max error = %g\n", e1, e2);
}
